// ============================================================================
// Copyright (c) 2018 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Mon Apr  9 10:58:33 2018
// ============================================================================

`define ENABLE_FPGA_DDR3
//`define ENABLE_HPS
//`define ENABLE_HPS_EMMC

module TSOM_top(

      ///////// Buttons /////////
      input    [ 1: 0]   KEY, //KEY is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is High-Active

      ///////// HDMI /////////
      inout              HDMI_LRCLK,
      inout              HDMI_MCLK,
      inout              HDMI_SCLK,
      output             HDMI_TX_CLK,
      output             HDMI_TX_HS,
      output             HDMI_TX_VS,
      output   [23: 0]   HDMI_TX_D,
      output             HDMI_TX_DE,
      inout              HDMI_I2C_SCL,
      inout              HDMI_I2C_SDA,
      input              HDMI_TX_INT,
      inout              HDMI_I2S0,

      ///////// ADC /////////
      output             ADC_SCK,
      input              ADC_SDO,
      output             ADC_SDI,
      output             ADC_CONVST,

      ///////// FPGA /////////
      input              FPGA_CLK1_50,
      input              FPGA_CLK2_50,

      inout    [ 4: 0]   FPGA_GPIO,

`ifdef ENABLE_FPGA_DDR3
      output             FPGA_DDR3_CK_p,
      output             FPGA_DDR3_CK_n,
      inout    [ 3: 0]   FPGA_DDR3_DQS_p,
      inout    [ 3: 0]   FPGA_DDR3_DQS_n,
      output   [ 1: 0]   FPGA_DDR3_CS_n,
      output   [15: 0]   FPGA_DDR3_ADDR,
      output   [ 2: 0]   FPGA_DDR3_BA,
      output             FPGA_DDR3_CAS_n,
      output   [ 1: 0]   FPGA_DDR3_CKE,
      output   [ 3: 0]   FPGA_DDR3_DM,
      inout    [31: 0]   FPGA_DDR3_DQ,
      output   [ 1: 0]   FPGA_DDR3_ODT,
      output             FPGA_DDR3_RAS_n,
      output             FPGA_DDR3_RESET_n,
      input    [ 1: 0]   FPGA_DDR3_RZQ,
      output             FPGA_DDR3_WE_n,
`endif

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output   [15: 0]   HPS_DDR3_ADDR,
      output   [ 2: 0]   HPS_DDR3_BA,
      output             HPS_DDR3_CAS_n,
      output   [ 1: 0]   HPS_DDR3_CKE,
      output             HPS_DDR3_CK_n,
      output             HPS_DDR3_CK_p,
      output   [ 1: 0]   HPS_DDR3_CS_n,
      output   [ 3: 0]   HPS_DDR3_DM,
      inout    [31: 0]   HPS_DDR3_DQ,
      inout    [ 3: 0]   HPS_DDR3_DQS_n,
      inout    [ 3: 0]   HPS_DDR3_DQS_p,
      output   [ 1: 0]   HPS_DDR3_ODT,
      output             HPS_DDR3_RAS_n,
      output             HPS_DDR3_RESET_n,
      input              HPS_DDR3_RZQ,
      output             HPS_DDR3_WE_n,
      output             HPS_ENET_GTX_CLK,
      inout              HPS_ENET_INT_n,
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      input              HPS_ENET_RX_DV,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      output             HPS_ENET_TX_EN,
      inout    [ 3: 0]   HPS_FLASH_DATA,
      output             HPS_FLASH_DCLK,
      output             HPS_FLASH_NCSO,
      
      inout              HPS_RPI_GPIO02,
      inout              HPS_RPI_GPIO03,
      inout              HPS_RPI_GPIO04,
      inout              HPS_RPI_GPIO07,
      inout              HPS_RPI_GPIO08,
      inout              HPS_RPI_GPIO09,
      inout              HPS_RPI_GPIO10,
      inout              HPS_RPI_GPIO11,
      inout              HPS_RPI_GPIO14,
      inout              HPS_RPI_GPIO15,
      inout              HPS_RPI_GPIO17,
      inout              HPS_RPI_GPIO18,
      inout              HPS_RPI_GPIO22,
      inout              HPS_RPI_GPIO23,
      inout              HPS_RPI_GPIO24,
      inout              HPS_RPI_GPIO25,
      inout              HPS_RPI_GPIO27,

      inout              HPS_EMMC_SEL,
      output             HPS_SDMMC_CLK,
      inout              HPS_SDMMC_CMD,
`ifdef ENABLE_HPS_EMMC
      inout    [ 7: 0]   HPS_SDMMC_DATA,
      output             HPS_EMMC_RST_n,
`else
      inout    [ 3: 0]   HPS_SDMMC_DATA,
`endif

      input              HPS_UART_RX,
      output             HPS_UART_TX,

      input              HPS_USB_CLKOUT,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// TMD0 /////////
      inout    [ 7: 0]   TMD0_D,

      ///////// TMD1 /////////
      inout    [ 7: 0]   TMD1_D
);


//=======================================================
//  REG/WIRE declarations
//=======================================================

wire global_reset_n;
wire afi_clk; // clock for test controllers
wire ddr3_emif_usr_reset_n;
wire ddr3_emif_insert_error_n;

//=======================================================
//  Structural coding
//=======================================================


assign global_reset_n = KEY[0];


DDR3 DDR3_Inst(
		/*input  wire         */    .pll_ref_clk(FPGA_CLK2_50),               
		/*input  wire         */    .global_reset_n(global_reset_n),            
		/*input  wire         */    .soft_reset_n(1'b1),              
		/*output wire         */    .afi_clk(afi_clk),                   
		/*output wire         */    .afi_half_clk(),              
		/*output wire         */    .afi_reset_n(ddr3_emif_usr_reset_n),               
		/*output wire         */    .afi_reset_export_n(),   
		

		/*output wire [14:0]  */    .mem_a(FPGA_DDR3_ADDR),                     
		/*output wire [2:0]   */    .mem_ba(FPGA_DDR3_BA),                    
		/*output wire [0:0]   */    .mem_ck(FPGA_DDR3_CK_p),                    
		/*output wire [0:0]   */    .mem_ck_n(FPGA_DDR3_CK_n),                  
		/*output wire [0:0]   */    .mem_cke(FPGA_DDR3_CKE),                   
		/*output wire [0:0]   */    .mem_cs_n(FPGA_DDR3_CS_n),                  
		/*output wire [3:0]   */    .mem_dm(FPGA_DDR3_DM),                    
		/*output wire [0:0]   */    .mem_ras_n(FPGA_DDR3_RAS_n),                 
		/*output wire [0:0]   */    .mem_cas_n(FPGA_DDR3_CAS_n),                 
		/*output wire [0:0]   */    .mem_we_n(FPGA_DDR3_WE_n),                  
		/*output wire         */    .mem_reset_n(FPGA_DDR3_RESET_n),               
		/*inout  wire [31:0]  */    .mem_dq(FPGA_DDR3_DQ),                    
		/*inout  wire [3:0]   */    .mem_dqs(FPGA_DDR3_DQS_p),                   
		/*inout  wire [3:0]   */    .mem_dqs_n(FPGA_DDR3_DQS_n),                 
		/*output wire [0:0]   */    .mem_odt(FPGA_DDR3_ODT),                   
		/*input  wire         */    .oct_rzqin(FPGA_DDR3_RZQ),  
		
		
		/*output wire         */    .avl_ready(fpga_ddr3_avl_ready),                 
		/*input  wire         */    .avl_burstbegin(1'b1),            
		/*input  wire [25:0]  */    .avl_addr(fpga_ddr3_avl_addr),                  
		/*output wire         */    .avl_rdata_valid(fpga_ddr3_avl_rdata_valid),           
		/*output wire [127:0] */    .avl_rdata(fpga_ddr3_avl_rdata),                 
		/*input  wire [127:0] */    .avl_wdata(fpga_ddr3_avl_wdata),                 
		/*input  wire [15:0]  */    .avl_be(16'hffff),                    
		/*input  wire         */    .avl_read_req(fpga_ddr3_avl_read_req),              
		/*input  wire         */    .avl_write_req(fpga_ddr3_avl_write_req),             
		/*input  wire [2:0]   */    .avl_size(fpga_ddr3_avl_size),                  
		/*output wire         */    .local_init_done(fpga_ddr3_local_init_done),           
		/*output wire         */    .local_cal_success(fpga_ddr3_local_cal_success),         
		/*output wire         */    .local_cal_fail(fpga_ddr3_local_cal_fail)            

	);




/// test status ..
//DDR3 Verify (A)
parameter DDR3_AVALON_ADDR_W = 26;
parameter DDR3_AVALON_DATA_W = 128;


wire fpga_ddr3_test_pass/*synthesis keep*/;
wire fpga_ddr3_test_fail/*synthesis keep*/;
wire fpga_ddr3_test_complete/*synthesis keep*/;
wire fpga_ddr3_local_init_done/*synthesis keep*/;
wire fpga_ddr3_local_cal_success/*synthesis keep*/;
wire fpga_ddr3_local_cal_fail/*synthesis keep*/;
	
wire         							fpga_ddr3_avl_ready;                  //         	 .avl.waitrequest_n
wire          							fpga_ddr3_avl_burstbegin;             //             .beginbursttransfer
wire [DDR3_AVALON_ADDR_W-1:0]   	fpga_ddr3_avl_addr;                   //             .address
wire          							fpga_ddr3_avl_rdata_valid;            //             .readdatavalid
wire [DDR3_AVALON_DATA_W-1:0]  	fpga_ddr3_avl_rdata;                  //             .readdata
wire [DDR3_AVALON_DATA_W-1:0]  	fpga_ddr3_avl_wdata;                  //             .writedata
wire          							fpga_ddr3_avl_read_req;               //             .read
wire          							fpga_ddr3_avl_write_req;              //             .write
wire [2:0]    							fpga_ddr3_avl_size;                   //             .burstcount



Avalon_bus_RW_Test DDR3_verify(
		    .iCLK						(afi_clk),
		    .iRST_n						(ddr3_emif_usr_reset_n),
			 .insert_error				(KEY[1]),
		
		    .local_init_done			(fpga_ddr3_local_cal_success),
		    .avl_waitrequest_n		(fpga_ddr3_avl_ready),                 
		    .avl_address				(fpga_ddr3_avl_addr),                      
		    .avl_readdatavalid		(fpga_ddr3_avl_rdata_valid),                 
		    .avl_readdata				(fpga_ddr3_avl_rdata),                      
		    .avl_writedata			(fpga_ddr3_avl_wdata),                     
		    .avl_read					(fpga_ddr3_avl_read_req),                          
		    .avl_write					(fpga_ddr3_avl_write_req),    
		    .avl_burstbegin			(fpga_ddr3_avl_burstbegin),
		    .avl_size					(fpga_ddr3_avl_size),
		
		    .drv_status_pass			(fpga_ddr3_test_pass),
		    .drv_status_fail			(fpga_ddr3_test_fail),
		    .drv_status_test_complete(fpga_ddr3_test_complete),
			 
);
defparam DDR3_verify.ADDR_W = DDR3_AVALON_ADDR_W;
defparam DDR3_verify.DATA_W = DDR3_AVALON_DATA_W;
	
	
wire        heart_led;
heart_beat  heart_beat_0 ( .CLK(FPGA_CLK2_50 ),     .CLK_FREQ  (50_000_000) , . CK_1HZ (heart_led) );

assign LED[0] =  (fpga_ddr3_local_cal_success) ?(fpga_ddr3_test_pass & fpga_ddr3_test_complete):heart_led;
assign LED[1] =  heart_led;





endmodule
