// ============================================================================
// Copyright (c) 2018 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Mon Apr  9 10:58:33 2018
// ============================================================================

//`define ENABLE_FPGA_DDR3
//`define ENABLE_HPS
//`define ENABLE_HPS_EMMC

module TSOM_top(

      ///////// Buttons /////////
      input    [ 1: 0]   KEY, //KEY is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is High-Active

      ///////// HDMI /////////
      inout              HDMI_LRCLK,
      inout              HDMI_MCLK,
      inout              HDMI_SCLK,
      output             HDMI_TX_CLK,
      output             HDMI_TX_HS,
      output             HDMI_TX_VS,
      output   [23: 0]   HDMI_TX_D,
      output             HDMI_TX_DE,
      inout              HDMI_I2C_SCL,
      inout              HDMI_I2C_SDA,
      input              HDMI_TX_INT,
      inout              HDMI_I2S0,

      ///////// ADC /////////
      output             ADC_SCK,
      input              ADC_SDO,
      output             ADC_SDI,
      output             ADC_CONVST,

      ///////// FPGA /////////
      input              FPGA_CLK1_50,
      input              FPGA_CLK2_50,

      inout    [ 4: 0]   FPGA_GPIO,

`ifdef ENABLE_FPGA_DDR3
      output             FPGA_DDR3_CK_p,
      output             FPGA_DDR3_CK_n,
      inout    [ 3: 0]   FPGA_DDR3_DQS_p,
      inout    [ 3: 0]   FPGA_DDR3_DQS_n,
      output   [ 1: 0]   FPGA_DDR3_CS_n,
      output   [15: 0]   FPGA_DDR3_ADDR,
      output   [ 2: 0]   FPGA_DDR3_BA,
      output             FPGA_DDR3_CAS_n,
      output   [ 1: 0]   FPGA_DDR3_CKE,
      output   [ 3: 0]   FPGA_DDR3_DM,
      inout    [31: 0]   FPGA_DDR3_DQ,
      output   [ 1: 0]   FPGA_DDR3_ODT,
      output             FPGA_DDR3_RAS_n,
      output             FPGA_DDR3_RESET_n,
      input    [ 1: 0]   FPGA_DDR3_RZQ,
      output             FPGA_DDR3_WE_n,
`endif

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output   [15: 0]   HPS_DDR3_ADDR,
      output   [ 2: 0]   HPS_DDR3_BA,
      output             HPS_DDR3_CAS_n,
      output   [ 1: 0]   HPS_DDR3_CKE,
      output             HPS_DDR3_CK_n,
      output             HPS_DDR3_CK_p,
      output   [ 1: 0]   HPS_DDR3_CS_n,
      output   [ 3: 0]   HPS_DDR3_DM,
      inout    [31: 0]   HPS_DDR3_DQ,
      inout    [ 3: 0]   HPS_DDR3_DQS_n,
      inout    [ 3: 0]   HPS_DDR3_DQS_p,
      output   [ 1: 0]   HPS_DDR3_ODT,
      output             HPS_DDR3_RAS_n,
      output             HPS_DDR3_RESET_n,
      input              HPS_DDR3_RZQ,
      output             HPS_DDR3_WE_n,
      output             HPS_ENET_GTX_CLK,
      inout              HPS_ENET_INT_n,
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      input              HPS_ENET_RX_DV,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      output             HPS_ENET_TX_EN,
      inout    [ 3: 0]   HPS_FLASH_DATA,
      output             HPS_FLASH_DCLK,
      output             HPS_FLASH_NCSO,
      
      inout              HPS_RPI_GPIO02,
      inout              HPS_RPI_GPIO03,
      inout              HPS_RPI_GPIO04,
      inout              HPS_RPI_GPIO07,
      inout              HPS_RPI_GPIO08,
      inout              HPS_RPI_GPIO09,
      inout              HPS_RPI_GPIO10,
      inout              HPS_RPI_GPIO11,
      inout              HPS_RPI_GPIO14,
      inout              HPS_RPI_GPIO15,
      inout              HPS_RPI_GPIO17,
      inout              HPS_RPI_GPIO18,
      inout              HPS_RPI_GPIO22,
      inout              HPS_RPI_GPIO23,
      inout              HPS_RPI_GPIO24,
      inout              HPS_RPI_GPIO25,
      inout              HPS_RPI_GPIO27,

      inout              HPS_EMMC_SEL,
      output             HPS_SDMMC_CLK,
      inout              HPS_SDMMC_CMD,
`ifdef ENABLE_HPS_EMMC
      inout    [ 7: 0]   HPS_SDMMC_DATA,
      output             HPS_EMMC_RST_n,
`else
      inout    [ 3: 0]   HPS_SDMMC_DATA,
`endif

      input              HPS_UART_RX,
      output             HPS_UART_TX,

      input              HPS_USB_CLKOUT,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// TMD0 /////////
      inout    [ 7: 0]   TMD0_D,

      ///////// TMD1 /////////
      inout    [ 7: 0]   TMD1_D
);


//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  Structural coding
//=======================================================




endmodule
